#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    uint8_t uint8_eq_const_0_0;
    uint32_t uint32_eq_const_1_0;
    uint8_t uint8_eq_const_2_0;
    uint64_t uint64_eq_const_3_0;
    uint64_t uint64_eq_const_4_0;
    uint8_t uint8_eq_const_5_0;
    uint8_t uint8_eq_const_6_0;
    uint64_t uint64_eq_const_7_0;
    uint32_t uint32_eq_const_8_0;
    uint64_t uint64_eq_const_9_0;
    uint8_t uint8_eq_const_10_0;
    uint32_t uint32_eq_const_11_0;
    uint8_t uint8_eq_const_12_0;
    uint8_t uint8_eq_const_13_0;
    uint16_t uint16_eq_const_14_0;

    if (size < 53)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&uint8_eq_const_0_0, &data[i], 1);
    i += 1;
    memcpy(&uint32_eq_const_1_0, &data[i], 4);
    i += 4;
    memcpy(&uint8_eq_const_2_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_3_0, &data[i], 8);
    i += 8;
    memcpy(&uint64_eq_const_4_0, &data[i], 8);
    i += 8;
    memcpy(&uint8_eq_const_5_0, &data[i], 1);
    i += 1;
    memcpy(&uint8_eq_const_6_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_7_0, &data[i], 8);
    i += 8;
    memcpy(&uint32_eq_const_8_0, &data[i], 4);
    i += 4;
    memcpy(&uint64_eq_const_9_0, &data[i], 8);
    i += 8;
    memcpy(&uint8_eq_const_10_0, &data[i], 1);
    i += 1;
    memcpy(&uint32_eq_const_11_0, &data[i], 4);
    i += 4;
    memcpy(&uint8_eq_const_12_0, &data[i], 1);
    i += 1;
    memcpy(&uint8_eq_const_13_0, &data[i], 1);
    i += 1;
    memcpy(&uint16_eq_const_14_0, &data[i], 2);
    i += 2;


    if (uint8_eq_const_0_0 == 180)
    if (uint32_eq_const_1_0 == 4030293447)
    if (uint8_eq_const_2_0 == 133)
    if (uint64_eq_const_3_0 == 10896711771457081448u)
    if (uint64_eq_const_4_0 == 12760587372237346721u)
    if (uint8_eq_const_5_0 == 88)
    if (uint8_eq_const_6_0 == 5)
    if (uint64_eq_const_7_0 == 9303093969892355514u)
    if (uint32_eq_const_8_0 == 1553127960)
    if (uint64_eq_const_9_0 == 8030002510501216526u)
    if (uint8_eq_const_10_0 == 90)
    if (uint32_eq_const_11_0 == 1236274275)
    if (uint8_eq_const_12_0 == 156)
    if (uint8_eq_const_13_0 == 212)
    if (uint16_eq_const_14_0 == 42137)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
